'use strict';

exports.__esModule = true;
exports.default = buildErrorMessage;

var _Constant = require('../enums/Constant');

var _Constant2 = _interopRequireDefault(_Constant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @desc Builds multiline error message with debug info.
 *
 */
function buildErrorMessage(_ref) {
  var layerId = _ref.layerId,
      fieldId = _ref.fieldId,
      message = _ref.message;

  var normalizedMessage = Array.isArray(message) ? message : [message];
  var isDefaultLayerId = layerId === _Constant2.default.DEFAULT_LAYER_ID;
  var layerIdOutput = layerId && !isDefaultLayerId ? '    Layer: ' + layerId : null;
  var fieldIdOutput = fieldId ? '    Field: ' + fieldId : null;
  var debugInfoTitle = layerIdOutput || fieldIdOutput ? '--- Debug info:' : null;

  var errorMessage = normalizedMessage.concat(debugInfoTitle, layerIdOutput, fieldIdOutput).filter(function (v) {
    return v;
  }).join('\n');

  return '[react-validation-layer]: ' + errorMessage;
}