'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = getFieldsPropsState;

var _Constant = require('../enums/Constant');

var _Constant2 = _interopRequireDefault(_Constant);

var _getFieldHandler = require('./getFieldHandler');

var _ids = require('./ids');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @desc On each update layer calculates DOM props for each field and stores it in state.
 *       This function calcultates next slice of the state with the fields DOM props.
 *
 */
function getFieldsPropsState(layerId, normalizedFields, data, propsLevelTransformBeforeRender, isSubmitting) {
  return normalizedFields.reduce(function (fields, field) {
    var _fieldPropsStateId, _extends2;

    var fieldDomId = (0, _ids.buildFieldDomId)(layerId, field.keyPath);
    var fieldPropsStateId = (0, _ids.buildFieldPropsStateId)(field.id);

    // $FlowIgnoreMe: We're making sure that value at keyPath is not an object on normalization
    var fieldValue = (0, _utils.fetchProp)(data, field.keyPath);
    var fieldNormalizedDomValue = (0, _utils.normalizeValueForDom)(fieldValue);

    var transformBeforeRender = (0, _getFieldHandler.getFieldValueHandler)(layerId, field.id, 'transformBeforeRender', field.transformBeforeRender, propsLevelTransformBeforeRender);

    var fieldDomValue = transformBeforeRender ? transformBeforeRender(fieldNormalizedDomValue, data) : fieldNormalizedDomValue;

    var isDisabled = isSubmitting || field.disabled;

    return _extends({}, fields, (_extends2 = {}, _extends2[fieldPropsStateId] = (_fieldPropsStateId = {}, _fieldPropsStateId[_Constant2.default.FIELD_ID_DOM_DATA_ATTRIBUTE] = field.id, _fieldPropsStateId.id = fieldDomId, _fieldPropsStateId.name = field.id, _fieldPropsStateId.value = fieldDomValue, _fieldPropsStateId.disabled = isDisabled, _fieldPropsStateId), _extends2));
  }, {});
}