'use strict';

exports.__esModule = true;
exports.onBlur = undefined;

var _utils = require('../utils');

/**
 * @desc Async validation will be triggered on each blur event.
 *
 */
var onBlur = exports.onBlur = function onBlur(field, value, stateContainer) {
  stateContainer.setBluredField(field.id);
  stateContainer.setEmittedField(field.id);

  // [For ]: we're making sure it's fine in async validation method
  if (!field.validateAsync) throw new Error();

  // $FlowFixMe: No idea yet how to handle `async | debounced-async` case
  return field.validateAsync(value).then(function (results) {
    return {
      resolution: (0, _utils.buildCompleteAsyncValidationResults)(field.id, results, stateContainer.getPropsLevelStatuses(), stateContainer.getLayerId()),
      forValue: value
    };
  });
};