'use strict';

exports.__esModule = true;
exports.onFirstBlur = undefined;

var _utils = require('../utils');

var _utils2 = require('../../utils');

/**
 * @desc According to this strategy Layer won't emit any results
 *       until user blures away from a field.
 *       After first results are emitted-feedback is provided on every change.
 *
 */
var onFirstBlur = exports.onFirstBlur = function onFirstBlur(field, value, data, event, stateContainer) {
  var validationState = (0, _utils.buildCompleteSyncValidationResults)(field, value, data, stateContainer.getPropsLevelStatuses(), stateContainer.getLayerId());

  if (event && (0, _utils2.isBlurEvent)(event)) {
    stateContainer.setBluredField(field.id);
    stateContainer.setEmittedField(field.id);
    return validationState;
  }

  if (stateContainer.getEmittedField(field.id)) {
    return validationState;
  }

  return (0, _utils.buildEmptyValidationResults)();
};