'use strict';

exports.__esModule = true;
exports.onFirstSubmit = undefined;

var _utils = require('../utils');

/**
 * @desc According to this strategy Layer won't emit any results
 *       until user submits the form.
 *       After first results are emitted-feedback is provided on every change.
 *
 */
var onFirstSubmit = exports.onFirstSubmit = function onFirstSubmit(field, value, data, event, stateContainer) {
  if (stateContainer.getFormWasSubmitted()) {
    stateContainer.setEmittedField(field.id);
    return (0, _utils.buildCompleteSyncValidationResults)(field, value, data, stateContainer.getPropsLevelStatuses(), stateContainer.getLayerId());
  }

  return (0, _utils.buildEmptyValidationResults)();
};