'use strict';

exports.__esModule = true;
exports.onFirstSuccess = undefined;

var _utils = require('../utils');

/**
 * @desc According to this strategy Layer won't emit any results
 *       until user types in valid value.
 *       After first results are emitted-feedback is provided on every change.
 *
 */
var onFirstSuccess = exports.onFirstSuccess = function onFirstSuccess(field, value, data, event, stateContainer) {
  var validationState = (0, _utils.buildCompleteSyncValidationResults)(field, value, data, stateContainer.getPropsLevelStatuses(), stateContainer.getLayerId());

  if (stateContainer.getEmittedField(field.id)) {
    return validationState;
  }

  if (validationState.valid) {
    stateContainer.setEmittedField(field.id);
    return validationState;
  }

  return (0, _utils.buildEmptyValidationResults)();
};